package primerdesigner;

import org.synbiowave.AbstractSynBioWaveRobot;
import org.synbiowave.biojava.SequenceUtils;
import org.synbiowave.menu.MenuItem;
import org.synbiowave.menu.MenuItemFactory;
import org.synbiowave.menu.items.Formular;
import org.synbiowave.workspace.Sequence;
import com.google.wave.api.*;
import com.google.wave.api.event.*;

@SuppressWarnings("serial")
public class PrimerDesignerServlet extends AbstractSynBioWaveRobot {

  public PrimerDesignerServlet()
  {
	  super.setupOAuth("116644257249","pUg141rQP6eWEikPJsgIrK12","http://gmodules.com/api/rpc");
	  super.setupOAuth("116644257249","pUg141rQP6eWEikPJsgIrK12","http://sandbox.gmodules.com/api/rpc");
	  super.setAllowUnsignedRequests(true);

  }
  @Override
  protected String getRobotName() {
    return "SynBioWave Primerdesigner";
  }

  @Override
  protected String getRobotAvatarUrl() {
    return "http://synbiowave-primerdesigner.appspot.com/avatar.png";
  }

  @Override
  protected String getRobotProfilePageUrl() {
    return "http://www.synbiowave.org";
  }

  @Override
  public void onWaveletSelfAdded(WaveletSelfAddedEvent event) {
	   super.onSynBioWaveRobotSelfAdded(event);
  }

  @Override
  public void onWaveletParticipantsChanged(WaveletParticipantsChangedEvent event) {

  }
  
  @Override
  public void onGadgetStateChanged(GadgetStateChangedEvent event){
	  Blip blip = event.getBlip();
	  Gadget gadget = (Gadget) blip.getElements().get(event.getIndex());
	  if(gadget.getUrl().contentEquals("http://synbiowave-primerdesigner.appspot.com/primerGadget.xml")
			  && gadget.getProperty("submitted", "F").contains("T"))
	  {
		  Sequence primer1 = SequenceUtils.Deserialize(gadget.getProperty("primer1", ""));
		  Sequence primer2 = SequenceUtils.Deserialize(gadget.getProperty("primer2", ""));
		  primer1.setName(gadget.getProperty("p1n", "primer1"));
		  primer2.setName(gadget.getProperty("p2n", "primer2"));
		  primer1.publish(this, event.getWavelet(), false);
		  primer2.publish(this, event.getWavelet(), false);
	  }else{
		  super.onSynBioWaveGadgetChanged(event);
	  }
  }

@Override
public void createMenu(MenuItem menu, MenuItemFactory mif, Event event)
		throws Exception {
	MenuItem MainMenu = mif.createMenu("Primer Design");
	
	// Assemble Form
	Formular form = mif.createForm("Design Primer", "Select parameters:");
	form.addInputfield("Goal temp. (°C)", "60", "1");
	form.addInputfield("Start Position", "1", "2");
	form.addInputfield("End Position (leave empty for whole sequence)", "", "3");
	
	MenuItem help = mif.createButton("Help");
	// Connect Callback
	this.connectMenuCallBack(form, new PrimerDesignCallback());
	this.connectMenuCallBack(help, new PrimerDesignCallback());
	MainMenu.appendSubItem(form);
	MainMenu.appendSubItem(help);
	// Add the menu to the main robots menu
	menu.appendSubItem(MainMenu);
}
}